<?php
/**
 * author Sergio Antonio Ochoa Martinez - gnu.java.sergio@gmail.com
 * Copyright (c) 2006-2015 Paco Avila & Josep Llort
 * WebSites: www.openkm.com
 * 
 * No bytes were intentionally harmed during the development of this application.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */
defined('_JEXEC') or die;

use openkm\bean\Document;
use openkm\bean\Folder;
use openkm\bean\Node;
use openkm\bean\QueryResult;
use openkm\OKMWebServicesFactory;
use openkm\OKMWebservice10;
use openkm\bean\ResultSet;
use openkm\bean\QueryParams;
use openkm\bean\form\Input;
use openkm\bean\form\Select;
use openkm\bean\form\TextArea;
use openkm\bean\form\CheckBox;
?>
<script type="text/javascript">

    $(document).ready(function() {
    var iDisplayLength = <?php echo $this->rowConfiguration->showEntries; ?>;
            var icon = <?php echo $this->rowConfiguration->icon; ?>;
            var size = <?php echo $this->rowConfiguration->size; ?>;
            var updateDate = <?php echo $this->rowConfiguration->updateDate; ?>;
            var author = <?php echo $this->rowConfiguration->author; ?>;
            var version = <?php echo $this->rowConfiguration->version; ?>;
            var iconValor = false;
            var sizeValor = false;
            var updateDateValor = false;
            var authorValor = false;
            var versionValor = false;
            if (icon == 1) {
    iconValor = true;
    }
    if (size === 1) {
    sizeValor = true;
    }
    if (updateDate == 1) {
    updateDateValor = true;
    }
    if (author == 1) {
    authorValor = true;
    }
    if (version == 1) {
    versionValor = true;
    }
    $('#tablaSearch').dataTable({
    "processing":true,
            "serverSide": true,
            "deferLoading": <?php echo $this->results->getTotal(); ?>,
            "iDisplayLength": iDisplayLength,
            "bFilter": false,
            "scrollX": true,
            "ajax": "index.php?option=com_openkm&view=search&task=pagination&format=json&id=<?php echo $this->rowConfiguration->idConfiguration; ?>",
            "aoColumns": [
            {"bSortable": false, "bSearchable": false, "bVisible": iconValor},
            {"bSortable": false, "bVisible": true},
            {"bSortable": false, "bVisible": sizeValor},
            {"bSortable": false, "bVisible": updateDateValor},
            {"bSortable": false, "bVisible": authorValor},
            {"bSortable": false, "bVisible": versionValor}
<?php for ($i = 0; $i < count($this->rowsMetadata); $i++) { ?>
                , {"bSortable": false, "bVisible": true}
<?php } ?>
            ],
            "aaSorting": [[0, "asc"]],
            "oLanguage": {
            "sProcessing": "<?php echo JText::_('COM_OPENKM_PLEASE_WAIT') ?>",
                    "sLengthMenu": "<?php echo JText::_('COM_OPENKM_SHOW') ?>_MENU_ <?php echo JText::_('COM_OPENKM_ENTRIES') ?>",
                                        "sZeroRecords": "<?php echo JText::_('COM_OPENKM_NOTHING_FOUND_SORRY') ?>",
                                        "sInfo": "<?php echo JText::_('COM_OPENKM_SHOWING') ?>_START_ <?php echo JText::_('COM_OPENKM_TO') ?> _END_ <?php echo JText::_('COM_OPENKM_OF') ?> _TOTAL_ <?php echo JText::_('COM_OPENKM_ENTRIES') ?>",
                                                            "sInfoEmpty": "<?php echo JText::_('COM_OPENKM_SHOWING') ?> 0 <?php echo JText::_('COM_OPENKM_TO') ?> 0 <?php echo JText::_('COM_OPENKM_OF') ?> 0 <?php echo JText::_('COM_OPENKM_ENTRIES') ?>",
                                                                                "sInfoFiltered": "(<?php echo JText::_('COM_OPENKM_FILTERED_FROM') ?> _MAX_ <?php echo JText::_('COM_OPENKM_TOTAL_ENTRIES') ?>)",
                                                                                "sInfoPostFix": "",
                                                                                "sSearch": "<?php echo JText::_('COM_OPENKM_SEARCH'); ?>",
                                                                                "sUrl": "",
                                                                                "oPaginate": {
                                                                                "sFirst": "<?php echo JText::_('COM_OPENKM_FIRST') ?>",
                                                                                        "sPrevious": "<?php echo JText::_('COM_OPENKM_PREVIOUS') ?>",
                                                                                        "sNext": "<?php echo JText::_('COM_OPENKM_NEXT') ?>",
                                                                                        "sLast": "<?php echo JText::_('COM_OPENKM_LAST') ?>"
                                                                                }
                                                                        }
                                                                });
                                                                });
</script>
<style type="text/css">
    #advanced{
        margin-top:10px;
        margin-bottom:10px;
    }
</style>
<?php

function optionLabel($options) {
    foreach ($options as $option) {
        if ($option->isSelected() == 'true') {
            return $option->getLabel();
        }
    }
}

function optionValue($options) {
    foreach ($options as $option) {
        if ($option->isSelected() == 'true') {
            return $option->getValue();
        }
    }
}

function printFolder(Folder $folder, OKMWebservice10 $ws, $rowsMetadata) {
    ?>
    <tr>
        <td align="center">
            <?php if ($folder->isHasChildren() == 'false') { ?>
                <img src="components/com_openkm/assets/images/menuitem_childs.png" /> 
            <?php } else {
                ?>
                <img src="components/com_openkm/assets/images/menuitem_empty.png" />   
            <?php } ?>            
        </td>
        <td style="white-space: nowrap;">
            <a  href="index.php?option=com_openkm&view=desktop&layout=view&enter=1&uuid=<?php echo $folder->getUuid(); ?>" >
                <?php
                echo substr($folder->getPath(), strrpos($folder->getPath(), '/') + 1);
                ?>
            </a>
        </td>
        <td>

        </td>
        <td style="white-space: nowrap;">            
            <?php
            $time = strtotime($folder->getCreated());
            echo date('d/m/Y h:i:s', $time);
            ?>
        </td>
        <td style="white-space: nowrap;">
            <?php echo $folder->getAuthor(); ?>
        </td>
        <td>           
        </td> 
        <?php
        if (!empty($rowsMetadata)) {

            $property = explode(".", $rowsMetadata[0]->property);
            $group = str_replace("okp", "okg", $property[0]);
            $formElements = $ws->getPropertyGroupProperties($folder->getUuid(), $group);

            foreach ($rowsMetadata as $rowMetadata) {
                ?>
                <td style="white-space: nowrap;">
                    <?php
                    foreach ($formElements as $formElement) {
                        if ($formElement instanceof Input) {
                            $name = $formElement->getName();
                            $value = $formElement->getValue();
                            if ($rowMetadata->property == $name) {
                                echo $value;
                            }
                        } else if ($formElement instanceof Select) {
                            $name = $formElement->getName();
                            if ($rowMetadata->property == $name) {
                                echo optionLabel($formElement->getOptions());
                            }
                        } else if ($formElement instanceof TextArea) {
                            $name = $formElement->getName();
                            $value = $formElement->getValue();
                            if ($rowMetadata->property == $name) {
                                echo $value;
                            }
                        } else if ($formElement instanceof CheckBox) {
                            $name = $formElement->getName();
                            $value = $formElement->isValue();
                            if ($rowMetadata->property == $name) {
                                echo $value;
                            }
                        }
                    }
                    ?>
                </td>
                <?php
            }
        }
        ?>
    </tr>
    <?php
}

function printDocument(Document $document, $rowConfiguration, OKMWebservice10 $ws, $rowsMetadata) {
    ?>
    <tr>
        <td align="center">
            <img src="<?php echo $rowConfiguration->url; ?>/mime/<?php echo $document->getMimeType(); ?>" />            
        </td>
        <td style="white-space: nowrap;">            
            <a  href="index.php?option=com_openkm&view=desktop&task=download&format=raw&uuid=<?php echo $document->getUuid(); ?>&id=<?php echo $rowConfiguration->idConfiguration; ?>" >                
                <?php echo substr($document->getPath(), strrpos($document->getPath(), '/') + 1); ?>
            </a>               
        </td>
        <td style="white-space: nowrap;">
            <?php echo formatSize($document->getActualVersion()->getSize()); ?>
        </td>
        <td style="white-space: nowrap;">
            <?php
            $time = strtotime($document->getCreated());
            echo date('d/m/Y h:i:s', $time);
            ?>
        </td>
        <td style="white-space: nowrap;">
            <?php echo $document->getAuthor(); ?>
        </td>
        <td style="white-space: nowrap;">
            <?php echo $document->getActualVersion()->getName(); ?>
        </td>
        <?php
        if (!empty($rowsMetadata)) {

            $property = explode(".", $rowsMetadata[0]->property);
            $group = str_replace("okp", "okg", $property[0]);
            $formElements = $ws->getPropertyGroupProperties($document->getUuid(), $group);

            foreach ($rowsMetadata as $rowMetadata) {
                ?>
                <td style="white-space: nowrap;">
                    <?php
                    foreach ($formElements as $formElement) {
                        if ($formElement instanceof Input) {
                            $name = $formElement->getName();
                            $value = $formElement->getValue();
                            if ($rowMetadata->property == $name) {
                                echo $value;
                            }
                        } else if ($formElement instanceof Select) {
                            $name = $formElement->getName();
                            if ($rowMetadata->property == $name) {
                                echo optionLabel($formElement->getOptions());
                            }
                        } else if ($formElement instanceof TextArea) {
                            $name = $formElement->getName();
                            $value = $formElement->getValue();
                            if ($rowMetadata->property == $name) {
                                echo $value;
                            }
                        } else if ($formElement instanceof CheckBox) {
                            $name = $formElement->getName();
                            $value = $formElement->isValue();
                            if ($rowMetadata->property == $name) {
                                echo $value;
                            }
                        }
                    }
                    ?>
                </td>
                <?php
            }
        }
        ?>
    </tr>
    <?php
}

function redondear($numero, $decimales) {
    $factor = pow(10, $decimales);
    return (round($numero * $factor) / $factor);
}

function formatSize($size) {
    $srt = "BIG";
    if ($size / 1024 < 1) {
        $srt = $size . " Bytes";
    } else if ($size / 1048576 < 1) {
        $srt = redondear(($size / 1024), 1) . " KB";
    } else if ($size / 1073741824 < 1) {
        $srt = redondear(($size / 1048576), 1) . " MB";
    } else if ($size / 1099511627776 < 1) {
        $srt = redondear(($size / 1073741824), 1) . " GB";
    }
    return $srt;
}

if ($this->error == 0) {
    ?>    
    <div id="advanced">
        <?php require_once ('form.php'); ?>
    </div>
    <table id="tablaSearch" width="100%" class="display" cellpadding="0" cellspacing="0" border="0">
        <thead>
            <tr>
                <th > </th>
                <th > <?php echo JText::_('COM_OPENKM_NAME') ?></th>
                <th > <?php echo JText::_('COM_OPENKM_SIZE') ?></th>
                <th style="white-space: nowrap;"> <?php echo JText::_('COM_OPENKM_UPDATE_DATE') ?></th>
                <th > <?php echo JText::_('COM_OPENKM_AUTHOR') ?></th>
                <th > <?php echo JText::_('COM_OPENKM_VERSION') ?></th>
                <?php foreach ($this->rowsMetadata as $rowMetadata) { ?>
                        <th style="white-space: nowrap;"><?php echo $rowMetadata->title; ?></th>
                <?php } ?>
            </tr>
        </thead>
        <tbody>
            <?php
            $ws = OKMWebServicesFactory::build($this->rowConfiguration->url, $this->rowConfiguration->user, $this->rowConfiguration->password);                                    
            
            foreach ($this->results->getResults() as $queryResult) {
                    if ($queryResult->getDocument() != null) {                        
                        printDocument($queryResult->getDocument(), $this->rowConfiguration,$ws,$this->rowsMetadata);
                    } else if ($queryResult->getFolder() != null) {
                        printFolder($queryResult->getFolder(),$ws,$this->rowsMetadata);                        
                    }   
                }                                            
            ?>
        </tbody>
    </table>

<?php } else { ?>   
    <h2><?php echo JText::_('COM_OPENKM_ERROR_THE_CONFIGURATION_IS_NOT_CORRECT_PLEASE_CHECK_YOUR_OPENKM_CONFIGURATION_TO_CONNECTO_TO') ?>.</h2>
    <p>
        <?= $this->okmMessage; ?>
    </p>
    <?php
} 